﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using com.google.zxing;

namespace CameraPreviewTest {

    public class PreviewFrameLuminanceSource : LuminanceSource {

        // プレビューフレームを格納するバッファ
        public byte[] Buffer { get; set; }

        public PreviewFrameLuminanceSource(int width, int height) : base(width, height) {
            Buffer = new byte[width * height];
        }

        /// <summary>
        /// バッファをsbyte[]型で取得する
        /// </summary>
        public override sbyte[] Matrix {
            get { 
                // Bufferをbyte[]からsbyte[]へキャスト
                return ((Buffer as Array) as sbyte[]); 
            }
        }

        /// <summary>
        ///  1ラインずつデータを取得
        /// </summary>
        public override sbyte[] getRow(int y, sbyte[] row) {
            // 前回確保したrowとサイズが異なる場合、再度確保しなおす
            if (row == null || row.Length < Width) {
                row = new sbyte[Width];
            }

            for (int i = 0; i < Height; i++) {
                row[i] = Convert.ToSByte(Buffer[i * Width + y]);
            }

            return row;
        }
    }
}
